// X^bNۃNXev[gStack̗pîPj

#include <iostream>
#include "Stack.h"
#include "ArrayStack.h"
#include "ListStack.h"
#include "VectorStack.h"

using namespace std;

enum StackType { ArraySTK = 1, ListSTK, VectorSTK };

//--- X^bN𐶐 ---//
template <class Type>
Stack<Type>* generate_Stack(StackType sw)
{
	switch (sw) {
	 case  ArraySTK : return new ArrayStack<Type>();
	 case  ListSTK :  return new ListStack<Type>();
	 default :        return new VectorStack<Type>();
	}
}

//--- ׂẴf[^|bvĕ\ ---//
template <class Type>
void pop_all(Stack<Type>& s)
{
	cout << '{'
	try {
		while (1)
			cout << s.pop() << ", ";
	} catch (Stack<Type>::Empty) {
		;
	}
	cout << "}";
}

int main()
{
	int type;

	do {
		cout << "X^bN̎ށi1cz^2cXg^3cvectorjF";
		cin >> type;
	} while (type < 0 || type > 2);

	Stack<int>* s = generate_Stack<int>(static_cast<StackType>(type));

	while (1) {
		int menu;
		cout << "(1)vbV  (2)|bv  (3)S|bv\ (0)IF";
		cin >> menu;
		if (menu == 0) break;

		switch (menu) {
		 int x;
		 case 1: cout << "f[^F";
				 cin >> x;
				 try {
					 s->push(x);
				 }
				 catch (Stack<int>::Overflow) {
					cout << "\aI[ot[܂B\n";
				 }
				 break;

		 case 2: try {
					x = s->pop();
				 	cout << "|bvf[^" << x << "łB\n"; 
				 }
				 catch (Stack<int>::Empty) {
					cout << "\aX^bN͋łB\n";
				 }
				 break;
		 }
	}
}
