// zNXev[gArrayibool^ւ̓ꉻj

#ifndef ___Class_Template_Array_Bool
#define ___Class_Template_Array_Bool

#include <limits>
#include "Array.h"

//===== zNXev[gArrayibool^ւ̓ꉻj=====//
template<> class Array<bool> {
	typedef unsigned char BYTE;
	static const int CHAR_BITS = std::numeric_limits<unsigned char>::digits;

	int nelem;		// bool^z̗vf
	int velem;		// bool^zi[邽߂BYTE^z̗vf
	BYTE* vec;		// BYTE^擪vfւ̃|C^

	// bool^sz̗vf̊i[ɕKvBYTE^z̗vf
	static int size_of(int sz) { return (sz + CHAR_BITS - 1) / CHAR_BITS; }

public:
	//=== rbgxNgioCgĵPrbgւ̎QƂ\߂̃NX ===//
	class BitOfByteRef {
		BYTE& vec;		// QƐBYTE
		int idx;		// QƐBYTẼrbgԍ

	public:
		BitOfByteRef(BYTE& r, int i) : vec(r), idx(i) { }		// RXgN^

		operator bool() const { return (vec >> idx) & 1U; }		// ^U擾

		BitOfByteRef& operator=(bool b) {						// ^Uݒ
			if (b)
				vec |= 1U << idx;
			else
				vec &= ~(1U << idx);
			return *this;
		}
	};

	//----- Y͈̓G[ -----//
	class IdxRngErr {
		const Array* ident;
		int index;
	public:
		IdxRngErr(const Array* p, int i) : ident(p), index(i) { }
		int Index() const { return index; }
	};

	//--- IRXgN^ ---//
	explicit Array(int sz, bool v = bool()) : nelem(sz), velem(size_of(sz)) {
		vec = new BYTE[velem];
		for (int i = 0; i < velem; i++)		// Svf
			vec[i] = v;
	}

	//--- Rs[RXgN^ ---//
	Array(const Array& x) {
		if (&x == this) {						// qgł΁c
			nelem = 0;
			vec = NULL;
		} else {
			nelem = x.nelem;					// vfxƓɂ
			velem = x.velem;					// vfxƓɂ
			vec = new BYTE[velem];				// z{̂m
			for (int i = 0; i < velem; i++)		// SvfRs[
				vec[i] = x.vec[i];
		}
	}

	//--- fXgN^ ---//
   ~Array() { delete[] vec; }

	//--- vfԂ ---//
	int size() const { return nelem; }

	//--- Zq= ---//
	Array& operator=(const Array& x) {
		if (&x != this) {					// głȂ΁c
			if (velem != x.velem) {			// O̗vfقȂ΁c
				delete[] vec;				// ƂƊmۂĂ̈
				velem = x.velem;			// Vvf
				vec = new BYTE[velem];		// Vɗ̈m
			}
			nelem = x.nelem;				// Vvf
			for (int i = 0; i < velem; i++)	// SvfRs[
				vec[i] = x.vec[i];
		}
		return *this;
	}

	//--- YZq[] ---//
	BitOfByteRef operator[](int i) {
		if (i < 0 || i >= nelem)
			throw IdxRngErr(this, i);				// Y͈̓G[o
		return BitOfByteRef(vec[i / CHAR_BITS], (i & (CHAR_BITS - 1)));
	}

	//--- YZq[] ---//
	bool operator[](int i) const {
		if (i < 0 || i >= nelem)
			throw IdxRngErr(this, i);				// Y͈̓G[o
		return (vec[i / CHAR_BITS] >> (i & (CHAR_BITS - 1)) & 1U) == 1;
	}
};

#endif
