// lNXev[gTwin

#ifndef ___Class_Twin
#define ___Class_Twin

#include <utility>
#include <algorithm>

//===== lNXev[g =====//
template <class Type> class Twin {
	Type v1;	// l
	Type v2;	// l

public:
	//--- RXgN^ ---//
	Twin(const Type& f = Type(), const Type& s = Type()) : v1(f), v2(s) { } 

	//--- Rs[RXgN^ ---//
	Twin(const Twin<Type>& t) : v1(t.first()), v2(t.second()) { }

	Type  first()  const { return v1; }			// lv1̃Qb^
	Type& first()        { return v1; }			// lv1̃Qb^Zb^

	Type  second() const { return v2; }			// lv2̃Qb^
	Type& second()       { return v2; }			// lv2̃Qb^Zb^

	void set(const Type& f, const Type& s) { v1 = f; v2 = s; }	// l̃Zb^

	Type min() const { return v1 < v2 ? v1 : v2; }	// ق̒l

	bool ascending() const { return v1 < v2 ; }		// l̂قH

	void sort() { if (!(v1 < v2)) std::swap(v1, v2); }	// \[g
};

//--- }q ---//
template <class Type> inline std::ostream& operator<<(std::ostream& os,
                                                      const Twin<Type>& t)
{
	return os << "[" << t.first() << ", " << t.second() << "]";
}

#endif
