// zNXIntArrayiQŁFwb_j

#ifndef ___Class_IntArray
#define ___Class_IntArray

//===== zNX ======//
class IntArray {
	int nelem;		// z̗vf
	int* vec;		// 擪vfւ̃|C^

	//--- Y̑Ó𔻒 ---//
	bool is_valid_index(int idx) const { return idx >= 0 && idx < nelem; }

public:
	//----- Y͈̓G[ -----//
	class IdxRngErr {
	private:
		const IntArray* ident;	// O𑗏oIuWFNgւ̃|C^
		int idx;				// O𑗏o邫ƂȂY̒l
	public:
		IdxRngErr(const IntArray* p, int i) : ident(p), idx(i) { }
		int index() const { return idx; }
	};

	//--- IRXgN^ ---//
	explicit IntArray(int size) : nelem(size) { vec = new int[nelem]; }

	//--- Rs[RXgN^ ---//
	IntArray(const IntArray& x);

	//--- fXgN^ ---//
	~IntArray() { delete[] vec; }

	//--- vfԂ ---//
	int size() const { return nelem; }

	//--- Zq= ---//
	IntArray& operator=(const IntArray& x);

	//--- YZq[] ---//
	int& operator[](int i) {
		if (!is_valid_index(i))
			throw IdxRngErr(this, i);		// Y͈̓G[o
		return vec[i];
	}

	//--- constœYZq[] ---//
	const int& operator[](int i) const {
		if (!is_valid_index(i))
			throw IdxRngErr(this, i);		// Y͈̓G[o
		return vec[i];
	}
};

#endif
