// NXQiRŁj
//		Line
//		HorzLine
//		VertLine

#ifndef ___Class_Line
#define ___Class_Line

#include <string>
#include <sstream>
#include <iostream>
#include "Shape.h"

//===== NXiۃNXj=====//
class Line : public Shape {
protected:
	int length;			// 

public:
	//--- RXgN^ ---//
	Line(int len) : length(len) { }

	//--- ilengthj̃Qb^ ---//
	int get_length() const { return length; }

	//--- ilengthj̃Zb^ ---//
	void set_length(int len) { length = len; }

	//--- fobOp\ ---//
	void debug() const {
		Shape::debug();
		std::cout << "lengthF" << length << '\n';
	}
};

//===== NX =====//
class HorzLine : public Line {
public:
	//--- RXgN^ ---//
	HorzLine(int len) : Line(len) { }

	//---  ---//
	HorzLine* clone() const {
		return new HorzLine(length);
	}

	//--- ` ---//
	void draw() const {
		for (int i = 1; i <= length; i++)
			std::cout << '-';
		std::cout << '\n';
	}

	//--- \ ---//
	std::string to_string() const {
		std::ostringstream os;
		os << "HorzLine(length:" << length << ")";
		return os.str();
	}
};

//===== NX =====//
class VertLine : public Line {
public:
	//--- RXgN^ ---//
	VertLine(int len) : Line(len) { }

	//---  ---//
	VertLine* clone() const {
		return new VertLine(length);
	}

	//--- ` ---//
	void draw() const {
		for (int i = 1; i <= length; i++)
			std::cout << "|\n";
	}

	//--- \ ---//
	std::string to_string() const {
		std::ostringstream os;
		os << "VertLine(length:" << length << ")";
		return os.str();
	}
};

#endif
