// \[gςݎOlNXev[gOrderedTrio

#include <string>
#include <utility>
#include <algorithm>
#include <iostream>

using namespace std;

// \[gςݎOlNXev[gOrderedTrio
template <class T> class OrderedTrio {
	T v1, v2, v3;

	void sort() {								// v1v2v3ƂȂ悤Ƀ\[g
		if (!(v1 < v2)) std::swap(v1, v2);
		if (!(v2 < v3)) std::swap(v2, v3);
		if (!(v1 < v2)) std::swap(v1, v2);
	}
public:
	//--- RXgN^ ---//
	OrderedTrio(const T& f1 = T(), const T& f2 = T(), const T& f3 = T()) 
			   : v1(f1), v2(f2), v3(f3) { sort(); } 

	//--- Rs[RXgN^ ---//
	OrderedTrio(const OrderedTrio<T>& t)
			   : v1(t.first()), v2(t.second()), v3(t.third()) { }

	T  first()  const { return v1; }			// lv1̃Qb^
	T& first()        { return v1; }			// lv1̃Qb^Zb^

	T  second() const { return v2; }			// lv2̃Qb^
	T& second()       { return v2; }			// lv2̃Qb^Zb^

	T  third()  const { return v3; }			// Olv3̃Qb^
	T& third()        { return v3; }			// Olv3̃Qb^Zb^
};

//--- }q ---//
template <class T>
inline std::ostream& operator<<(std::ostream& os, const OrderedTrio<T>& t)
{
	return os << "[" << t.first() << ", " << t.second()
								  << ", " << t.third() << "]";
}

//--- }qiTrio<std::string>^ւ̓ꉻj---//
template <>
inline std::ostream& operator<<(std::ostream& os, const OrderedTrio<std::string>& st)
{
	return os << "[\"" << st.first() << "\", \"" << st.second()
									 << "\", \"" << st.third() << "\"]";
}

int main()
{
	int v1, v2, v3;
	string s1, s2, s3;
	cout << "[1]F";	cin >> v1;
	cout << "[2]F";	cin >> v2;
	cout << "[3]F";	cin >> v3;
	cout << "[1]F";	cin >> s1;
	cout << "[2]F";	cin >> s2;
	cout << "[3]F";	cin >> s3;

	OrderedTrio<int> t1(v1, v2, v3);
	OrderedTrio<string> t2(s1, s2, s3);

	cout << "t1 = " << t1 << '\n';
	cout << "t2 = " << t2 << '\n';
}