﻿// 文字列を走査して表示

#include <string>
#include <iostream>

using namespace std;

//--- 文字列内のすべての文字を添字で走査して表示 ---//
void print_string_idx(string s)
{
	for (string::size_type i = 0; i < s.length(); i++)
		cout << s[i];
}

//--- 文字列内のすべての文字を反復子で走査して表示 ---//
void print_string_it1(string s)
{
	for (string::const_iterator i = s.begin(); i != s.end(); i++)
		cout << *i;
}

//--- [first, last)の全要素を順に表示 ---//
template<class InputIterator>
void print_string_it2(InputIterator first, InputIterator last)
{
	for (InputIterator i = first; i != last; i++)
		cout << *i;
}

int main()
{
	string s1;
	cout << "文字列を入力せよ：";
	cin >> s1;

	print_string_idx(s1);                     cout << '\n';
	print_string_it1(s1);                     cout << '\n';
	print_string_it2(s1.begin(), s1.end());   cout << '\n';
}
