﻿// 円周率をファイルに書き込んで読み取る（テキストモード）

#include <iomanip>
#include <fstream>
#include <iostream>

using namespace std;

int main()
{
	double pi = 3.14159265358979323846264338327950288;

	ofstream fos("pi.txt");
	if (!fos)
		cout << "\aファイルをオープンできません。\n";
	else {
		fos << pi;
		fos.close();
	}

	ifstream fis("pi.txt", ios_base::binary);
	if (!fis)
		cout << "\aファイルをオープンできません。\n";
	else {
		fis >> pi;
		cout << "piの値は" << fixed << setprecision(20) << pi << "です。\n";
		fis.close();
	}
}
