// zNXev[gArray

#ifndef ___ClassTemplate_Array
#define ___ClassTemplate_Array

//===== zNXev[g =====//
template <class Type> class Array {
	int nelem;		// z̗vf
	Type* vec;		// 擪vfւ̃|C^

	//--- Y̑Ó𔻒 ---//
	bool is_valid_index(int idx) { return idx >= 0 && idx < nelem; }

public:
	//----- Y͈̓G[ -----//
	class IdxRngErr {
		const Array* ident;
		int idx;
	public:
		IdxRngErr(const Array* p, int i) : ident(p), idx(i) { }
		int Index() const { return idx; }
	};

	//--- IRXgN^ ---//
	explicit Array(int size, const Type& v = Type()) : nelem(size) {
		vec = new Type[nelem];
		for (int i = 0; i < nelem; i++)
			vec[i] = v;
	}

	//--- Rs[RXgN^ ---//
	Array(const Array<Type>& x) {
		if (&x == this) {						// qgł΁c
			nelem = 0;
			vec = NULL;
		} else {
			nelem = x.nelem;					// vfxƓɂ
			vec = new Type[nelem];				// z{̂m
			for (int i = 0; i < nelem; i++)		// SvfRs[
				vec[i] = x.vec[i];
		}
	}

	//--- fXgN^ ---//
    ~Array() { delete[] vec; }

	//--- vfԂ ---//
	int size() const { return nelem; }

	//--- Zq= ---//
	Array& operator=(const Array<Type>& x) {
		if (&x != this) {					// głȂ΁c
			if (nelem != x.nelem) {			// O̗vfقȂ΁c
				delete[] vec;				// ƂƊmۂĂ̈
				nelem = x.nelem;			// Vvf
				vec = new Type[nelem];		// Vɗ̈m
			}
			for (int i = 0; i < nelem; i++)	// SvfRs[
				vec[i] = x.vec[i];
		}
		return *this;
	}

	//--- YZq[] ---//
	Type& operator[](int i)	{
		if (!is_valid_index(i))
			throw IdxRngErr(this, i);				// Y͈̓G[o
		return vec[i];
	}

	//--- constœYZq[] ---//
	const Type& operator[](int i) const {
		if (!is_valid_index(i))
			throw IdxRngErr(this, i);				// Y͈̓G[o
		return vec[i];
	}
};

#endif
