// tNXDateiwb_j

#ifndef ___Class_Date
#define ___Class_Date

#include <string>
#include <iostream>

//===== tNX =====//
class Date {
	int y;	// N
	int m;	// 
	int d;	// 

	static int dmax[];
	static int days_of_year(int year);				// yearN̓
	static int days_of_month(int year, int month);	// yearNmonth̓

public:

	//--- yearN͉[NH ---//
	static bool leap_year(int year) {
		return year % 4 == 0 && year % 100 != 0 || year % 400 == 0;
	}

	Date();										// ftHgRXgN^
	Date(int yy, int mm = 1, int dd = 1);		// RXgN^

	bool leap_year() const { return leap_year(y); }		// [NH

	int year()  const { return y; }			// Nԋp
	int month() const { return m; }			// ԋp
	int day()   const { return d; }			// ԋp

	void set_year(int yy) { y = yy; }		// Nyyɐݒ
	void set_month(int mm) { m = mm; }		// mmɐݒ
	void set_day(int dd) { d = dd; };		// ddɐݒ
	void set(int yy, int mm, int dd);		// tyyNmmddɐݒ

	Date preceding_day() const;				// O̓tԋp
	Date following_day() const;				// ̓tԋp

	int day_of_year() const;				// Ňoߓԋp

	int day_of_week() const;				// jԋp

	operator long() const;					// 1970N11̓

	Date& operator++();							// Pi߂iOuj
	Date  operator++(int);						// Pi߂iuj

	Date& operator--();							// P߂@iOuj
	Date  operator--(int);						// P߂@iuj

	Date& operator+=(int dn);					// dni߂iDate += intj
	Date& operator-=(int dn);					// dn߂@iDate -= intj

	Date operator+(int dn) const;					// dn߂iDate + intj
	friend Date operator+(int dn, const Date& day);	// dn߂iint + Datej

	Date operator-(int dn) const;				// dnO߂@iDate - intj

	long operator-(const Date& day) const;		// t̍߂iDate - Datej

	bool operator==(const Date& day) const;		// dayƓH
	bool operator!=(const Date& day) const;		// dayƈႤH

	bool operator> (const Date& day) const;		// dayォH
	bool operator>=(const Date& day) const;		// dayȍ~H
	bool operator< (const Date& day) const;		// dayOH
	bool operator<=(const Date& day) const;		// dayȑOH

	std::string to_string() const;				// \ԋp
};

std::ostream& operator<<(std::ostream& s, const Date& x);	// }q
std::istream& operator>>(std::istream& s, Date& x);	// oq

#endif
