// p񓙕ӎOp`NXQiRŁj
//		RectEquilTriangle
//		RectEquilTriangleLB
//		RectEquilTriangleRU

#ifndef ___Class_RectEquilTriangle
#define ___Class_RectEquilTriangle

#include <string>
#include <sstream>
#include <iostream>
#include "Shape.h"
#include "TwoDimensional.h"

//===== p񓙕ӎOp`NXiۃNXj=====//
class RectEquilTriangle : public Shape, public TwoDimensional {
protected:
	int length;			// Zӂ̒

public:
	//--- RXgN^ ---//
	RectEquilTriangle(int len) : length(len) { }

	//--- ʐς߂ ---//
	double get_area() const {
		return length * length / 2.0;
	}
};

//===== p񓙕ӎOp`NX =====//
class RectEquilTriangleLB : public RectEquilTriangle {
public:
	//--- RXgN^ ---//
	RectEquilTriangleLB(int len) : RectEquilTriangle(len) { }

	//---  ---//
	RectEquilTriangleLB* clone() const {
		return new RectEquilTriangleLB(length);
	}

	//--- ` ---//
	void draw() const {
		for (int i = 1; i <= length; i++) {
			for (int j = 1; j <= i; j++)
				std::cout << '*';
			std::cout << '\n';
		}
	}

	//--- \ ---//
	std::string to_string() const {
		std::ostringstream os;
		os << "RectEquilTriangleLB(length:" << length << ")";
		return os.str();
	}

	//--- fobOp\ ---//
	void debug() const {
		Shape::debug();
		std::cout << "NXFRectEquilTriangleLB\n";
		std::cout << "AhX" << this << '\n';
		std::cout << "lengthF" << length << '\n';
	}
};

//===== E㒼p񓙕ӎOp`NX =====//
class RectEquilTriangleRU : public RectEquilTriangle {
public:
	//--- RXgN^ ---//
	RectEquilTriangleRU(int len) : RectEquilTriangle(len) { }

	//---  ---//
	RectEquilTriangleRU* clone() const {
		return new RectEquilTriangleRU(length);
	}

	//--- ` ---//
	void draw() const {
		for (int i = 1; i <= length; i++) {
			for (int j = 1; j <= i - 1; j++)
				std::cout << ' ';
			for (int j = 1; j <= length - i + 1; j++)
				std::cout << '*';
			std::cout << '\n';
		}
	}

	//--- \ ---//
	std::string to_string() const {
		std::ostringstream os;
		os << "RectEquilTriangleRU(length:" << length << ")";
		return os.str();
	}

	//--- fobOp\ ---//
	void debug() const {
		Shape::debug();
		std::cout << "NXFRectEquilTriangleRU\n";
		std::cout << "AhX" << this << '\n';
		std::cout << "lengthF" << length << '\n';
	}
};

#endif
