// `NXRectangleiRŁj

#ifndef ___Class_Rectangle
#define ___Class_Rectangle

#include <string>
#include <sstream>
#include <iostream>
#include "Shape.h"
#include "TwoDimensional.h"

//===== `NX =====//
class Rectangle : public Shape, public TwoDimensional {
	int width;		// 
	int height;		// 

public:
	//--- RXgN^ ---//
	Rectangle(int w, int h) : width(w), height(h) { }

	//---  ---//
	Rectangle* clone() const {
		return new Rectangle(width, height);
	}

	//--- ` ---//
	void draw() const {
		for (int i = 1; i <= height; i++) {
			for (int j = 1; j <= width; j++)
				std::cout << '*';
			std::cout << '\n';
		}
	}

	//--- \ ---//
	std::string to_string() const {
		std::ostringstream os;
		os << "Rectangle(width:" << width << ", height:" << height << ")";
		return os.str();
	}

	//--- fobOp\ ---//
	void debug() const {
		Shape::debug();
		std::cout << "width F" << width << '\n';
		std::cout << "heightF" << height << '\n';
	}

	//--- ʐς߂ ---//
	double get_area() const {
		return width * height;
	}
};

#endif
