// X^bN NXev[gi`Xgɂj

#ifndef ___Class_ListStack
#define ___Class_ListStack

#include "Stack.h"

//===== `XgɂX^bN NXev[g =====//
template <class Type> class ListStack : public Stack<Type> {

	//=== m[h ===//
	template <class Type> class Node {
		friend class ListStack<Type>;
		Type* data;			// f[^
		Node* next;			// 㑱|C^i㑱m[hւ̃|C^j
	public:
		Node(Type* d, Node* n) : data(d), next(n) { }
	};

	Node<Type>* top;		// 擪m[hւ̃|C^
	Node<Type>* dummy;		// _~[m[hւ̃|C^

public:
	//--- RXgN^ ---//
	ListStack() {
		top = dummy = new Node<Type>(NULL, NULL);
	}

	//--- fXgN^ ---//
	~ListStack() {
		Node<Type>* ptr = top;
		while (ptr != dummy) {
			Node<Type>* next = ptr->next;
			delete ptr->data;
			delete ptr;
			ptr = next;
		}
		delete dummy;
	}

	//--- vbV ---//
	void push(const Type& x) {
		Node<Type>* ptr = top;
		try {
			top = new Node<Type>(new Type(x), ptr);
		} catch (const bad_alloc&) {
			throw Overflow();
		}
	}

	//--- |bv ---//
	Type pop() {
		if (top == dummy)						// X^bN͋
			throw Empty();
		else {
			Node<Type>* ptr = top->next;
			Type temp = *(top->data);
			delete top->data;
			delete top;
			top = ptr;
			return temp;
		}
	}
};

#endif
