﻿// 反復子によるベクトル要素の走査

#include <vector>
#include <iostream>

using namespace std;

int main()
{
	vector<int> v(5);	// 要素数は5
	int value = 0;

	// 先頭から末尾へと走査して値を代入
	for (vector<int>::iterator p = v.begin(); p != v.end(); p++)
		*p = ++value;

	// 先頭から末尾へと走査して値を表示
	for (vector<int>::const_iterator p = v.begin(); p != v.end(); p++) 
		cout << *p << ' ';
	cout << '\n';
}
