﻿// 文字列の配列

#include <string>
#include <iostream>

using namespace std;

//--- 要素数nの文字列の配列sを１文字ずつ走査して表示 ---*/
void put_string_ary(const string *s, size_t n)
{
	cout << "{ ";
	for (size_t i = 0; i < n; i++) {
		cout << '"';
		for (string::size_type j = 0; j < s[i].length(); j++)
			cout << s[i][j];
		cout << "\" ";
	}
	cout << "} ";
}

int main()
{
	string s1[3];		// 空の文字列3個
	string s2[3] = {"ABC", "123", "XYZ"};

	cout << "s1 = ";
	put_string_ary(s1, sizeof(s1)/sizeof(s1[0]));
	cout << '\n';

	cout << "s2 = ";
	put_string_ary(s2, sizeof(s2)/sizeof(s2[0]));
	cout << '\n';
}
